      subroutine acc_ASM
      
      include 'com_main.fc'
      
	! Input parameters for egwd
      REAL*8 :: vy1d(kgit)     !v-wind
      REAL*8 :: vx1d(kgit)     !u-wind
      REAL*8 :: temp1d(kgit)   !temperature
      REAL*8 :: cp1d(kgit)     !Cp profile
      REAL*8 :: hm(kgit)        !geopotential height (in m)
      REAL*8 :: pres(kgit)     !pressure (in Pa)
      REAL*8 :: rho(kgit)      !density
      
	! Output variables for egwd
      REAL*8 :: ut_gwd(kgit),vt_gwd(kgit),gwht(kgit),
     &          var_tot(kgit),flux_tot(kgit)
      
      
!       start_nsec=max(0,nsec-(30*24*3600))
      start_nsec=max(0,nsec-(60*24*3600))
      eff  = 1.-exp(-start_nsec/15./86400.)
      
      do i=1,igit
         do j=1,nb
         
          !input parameters
           do k=1,kgit
             vx1d(k)=an1(j,k,i,1) ! zonal wind
             vy1d(k)=an1(j,k,i,2) ! meridional wind
             temp1d(k)=an1(j,k,i,3) !temperature
	       hm(k)=fin1(j,k,i)/9.81 !geopotential height
             cp1d(k)=c_p !fixed value for c_p from init or strobel (=1005.)
!            cp1d=RgSGS/rm(k)*(7./2.*(1.-roxvmr(k))+5./2.*roxvmr(k)) !=cp_z from init or strobel
             pres(k)=1.e5*exp(-z(k)/7.) !presssure at height z
             rho(k)=dichte(k)*1.E3 !density profile from init or strobel 
           enddo
	
           call EYGwave(rho,vx1d,vy1d,temp1d,cp1d,hm, 
     &       ut_gwd, vt_gwd, pres, gwht, var_tot, flux_tot)
	     
	     !output parameters
           do k=1,kgit
	          fgru(k,i,j)=eff*real(ut_gwd(k))
		    fgrv(k,i,j)=eff*real(vt_gwd(k))
		    fgrt(k,i,j)=eff*real(gwht(k))
	     enddo
	     
         enddo
      enddo
            
      return
      end


